define([
'dojo/_base/declare', 
"dojo/on", 
"dojo/io/script",
"dojo/_base/lang", 
"dojo/_base/array", 
"dojo/request",
"dojo/cookie",
"dojo/dom-style",
"dijit/registry",

"dijit/_WidgetsInTemplateMixin",
"dijit/layout/ContentPane",
"dijit/form/CheckBox",
"dijit/form/Select",
"dijit/form/SimpleTextarea",
"dijit/ProgressBar",
"dijit/Dialog",
"dijit/Tooltip",
 
"dojox/widget/Standby",

  "esri/geometry/webMercatorUtils",
  "esri/domUtils",
  "esri/geometry/Point",
  "esri/geometry/Extent",
"esri/symbols/SimpleFillSymbol",
"esri/symbols/SimpleLineSymbol", 
"esri/symbols/SimpleMarkerSymbol",
"esri/Color",
"esri/InfoTemplate",

'jimu/PanelManager',
'jimu/BaseWidget'
],
	
function(declare, on, ioscript, lang, array, request, cookie, domStyle, registry,
		_WidgetsInTemplateMixin, ContentPane, CheckBox, Select, SimpleTextarea, ProgressBar, Dialog, Tooltip,
		Standby,
		webMercatorUtils, domUtils, Point, Extent, SimpleFillSymbol, SimpleLineSymbol, SimpleMarkerSymbol, Color, InfoTemplate,
    PanelManager, BaseWidget) {
  //To create a widget, you need to derive from BaseWidget.
  return declare([BaseWidget, _WidgetsInTemplateMixin], {

	baseClass: 'iso4app-widget',
	iso: null,
	startPoint: null,
	k: "87B7FB96-83DA-4FBD-A312-7822B96BB143",
	lastk: "87B7FB96-83DA-4FBD-A312-7822B96BB143",
	userk:"",
	layer: null, 
	polygon: null, 
	startPoint: null,
	polygons: [], 
	startPoints: [], 
	indicatorPolygons: [], 
	indicatorRange: [], 
	indicatorPopup: null,
	indicatorPopupId: null,
	removePrevious: true,
	colors: [[0,102,204,0.25],[255,51,0,0.25],[0,153,51,0.25],[0,0,0,0.25],[218,141,8,0.25],[230,0,255,0.25]], 
	colorsIdx: 0,
	colorGrid2d: 16744448,
	widgetClosed: true,
	spinner: null,
	spinnerRun: false,
//AGO20181130 START
  isoBatchTimer:null,
  isoBatchCoords:null,
  isoBatchCoordsIdx:null,
  isoBatchExtent:null,//bounding box
  isoBatchTotal:0,
  isoBatchProcessed:0,
  isoBatchErrors:0,//conteggi
  isoBatchLog:null,
//AGO20181130 END
	
    postCreate: function() {
      this.inherited(arguments);
      var that = this;
      
      ioscript.get({ 
    	  	url: location.protocol+"//www.iso4app.com/api/js?v=1.3&lkey=87B7FB96-83DA-4FBD-A312-7822B96BB143",
        //OLD url: location.origin+"/api/js?v=1.3&lkey=87B7FB96-83DA-4FBD-A312-7822B96BB143",
	        load: function() { 
	        	that._init();
	        } 
	    });


    },

    startup: function() {
      this.inherited(arguments);
    },

    onOpen: function(){
		this.widgetClosed=false;
    },

    onClose: function(){
		this.widgetClosed=true;
    },

    onMinimize: function(){
    },

    onMaximize: function(){
    },

    onSignIn: function(credential){
    },

    onSignOut: function(){
    },
	
	_init: function () {
		var that = this;
		
		this.iso = new iso4app.Engine();

   	//set StandBy widget for the spinner
		this.spinner = new Standby({
              target : this.map.container,
              zindex: "9999"
		});
        dojo.body().appendChild(this.spinner.domNode);
		 
		//Populate the iso type drop down list
        this.isoType.addOption(this._getIsoTypes());
		
		//listen map click
		on(this.map, "click", lang.hitch(this, this._onMapClick));
		
		//set api key
		this._setRegistrationKey(cookie("iso4app.key"));

		//populate the iso concavity drop down list
        this.isoConcavity.addOption(this._getIsoConcavities());
		//populate the iso buffering drop down list
        this.isoBuffering.addOption(this._getIsoBuffering());

		this._populateMenu();

		//Bind to change event for iso type drop down list, miles checkbox, mobility, speed type
		on(this.isoType, "change", lang.hitch(this, this._onChangeIsoType));
		on(this.miles, "change", lang.hitch(this, this._onChangeMiles));
		on(this.isoMobility, "change", lang.hitch(this, this._onChangeIsoMobility));
		on(this.isoSpeedType, "change", lang.hitch(this, this._onChangeIsoSpeedType));
		on(this.delPrevious, "change", lang.hitch(this, this._removePreviousChanged));
		on(this.removeAll, "click", lang.hitch(this, this._removeAll));
    on(this.btnUnion, "click", lang.hitch(this, this._isoUnion));//20180703
    on(this.btnBatch, "click", lang.hitch(this, this._isoBatch));//20181130
    on(this.btnGeoJson, "click", lang.hitch(this, this._screenGeoJson));//20180703
    on(this.btnKml, "click", lang.hitch(this, this._screenKml));//20180703

    //listen registration form on click
    on(this.formApiKeyOkBtn, "click", lang.hitch(this, this._setFormRegistrationKey));

    //AGO20181130 listen start batch on click
    on(this.formBatchStartBtn, "click", lang.hitch(this, this._startIsolinesBatch));
    on(this.formBatchCloseBtn, "click", lang.hitch(this, this._closeIsolinesBatch));
    on(this.formBatchStopBtn, "click", lang.hitch(this, this._stopIsolinesBatch));
    on(this.formBatchCopyBtn, "click", lang.hitch(this, this._batchResultsCopy));

    //disable infowin on click
		this.map.setInfoWindowOnClick(false);
		
		//listem on mouse move
		dojo.connect(this.map.graphics, "onMouseMove", function(evt) {
			var g = evt.graphic;
			if (g.getContent()!=null && g.getContent().length>0){
				that.map.infoWindow.setContent(g.getContent());
				that.map.infoWindow.setTitle(g.getTitle());
				that.map.infoWindow.show(evt.screenPoint,that.map.getInfoWindowAnchor(evt.screenPoint));
			}
        });
        dojo.connect(this.map.graphics, "onMouseOut", function() {
			that.map.infoWindow.hide();
		});
		
		// attach tooltips
		this.isoTypeLblTip.set("connectId", this.isoTypeLbl);
		this.isoDistanceLblTip.set("connectId", this.isoDistanceLbl);
		this.isoApproxLblTip.set("connectId", this.isoApproxLbl);
		this.isoSpeedLimitLblTip.set("connectId", this.isoSpeedLimitLbl);
		this.reduceQueueTimeLblTip.set("connectId", this.reduceQueueTimeLbl);
    this.fastestRoutingLblTip.set("connectId", this.fastestRoutingLbl);//20180703 new
    this.allowPedestrianBikeOnTrunkLblTip.set("connectId", this.allowPedestrianBikeOnTrunkLbl);//20180703 new
    this.restrictedAccessAreaLblTip.set("connectId", this.restrictedAccessAreaLbl);
    this.allowicyclesOnPedestrianLblTip.set("connectId", this.allowicyclesOnPedestrianLbl);
		this.categoryLblTip.set("connectId", this.categoryLbl);
		this.isoConcavityLblTip.set("connectId", this.isoConcavityLbl);
		this.isoBufferingLblTip.set("connectId", this.isoBufferingLbl);
	},

	_onChangeIsoType: function () {
		var isoApprox = this.isoApprox.get("value");
		var isoMobility = this.isoMobility.get("value");
		var isoSpeedType = this.isoSpeedType.get("value");
		
		//quando si torna da b o p a m si mette a "" la velocita
		if (isoMobility=="m") this.speedLimit.set("value","");
		
		this._populateMenu(null,null,isoApprox,isoMobility,isoSpeedType,true);
	},
	
	_onChangeIsoMobility: function () {
		var isoMobility = this.isoMobility.get("value");
		var isoSpeedType = this.isoSpeedType.get("value");
    var isoType = this.isoType.get("value");//20180703

		//quando si torna da b o p a m si mette a "" la velocita
		if (isoMobility=="m") this.speedLimit.set("value","");

    this.fastestRouting.set('disabled', !(isoType=="0" && isoMobility=="m"));//20180703
    this.allowPedestrianBikeOnTrunk.set('disabled', isoMobility=="m");//20180703
    if (isoMobility=="m") this.allowPedestrianBikeOnTrunk.set('value', false);//20180703
    this.allowicyclesOnPedestrian.set('disabled', !(isoMobility=="b"));
		
		this._suggestSpeedLimit(true);
	},
	
	_onChangeIsoSpeedType: function () {
		var isoSpeedType = this.isoSpeedType.get("value");
		var that = this; 
		
		this._suggestSpeedLimit(true);
		
	},
	
	_onChangeMiles: function () {
		var isoType = this.isoType.get("value");
		var isoValue = this.isoValues.get("value");
		var isoApprox = this.isoApprox.get("value");
		var isoMobility = this.isoMobility.get("value");
		var isoSpeedType = this.isoSpeedType.get("value");
		var speedLimitValue = this.speedLimit.get("value");
		var miles = this.miles.get("value");
		
		//populate menu
		this._populateMenu(isoType=="0"?isoValue:null,isoType=="1"?isoValue:null,isoApprox,isoMobility,isoSpeedType,false);

		//change speedLimit label
		this.isoSpeedLimitLbl.innerHTML=miles?"Speed limit (miles)":"Speed limit (km)";

		//speed limit unità misura
		if (!isNaN(speedLimitValue) && speedLimitValue.length>0){
			//console.log("speedLimit-> "+speedLimitValue);
			//console.log("speedLimit _km2miles-> "+this._km2miles(speedLimitValue));
			//console.log("speedLimit _miles2km-> "+this._miles2km(speedLimitValue));
			this.speedLimit.set("value",miles?this._km2miles(speedLimitValue):this._miles2km(speedLimitValue));
		}
		
	},

	_onMapClick: function (e) {
    var that = this;
	  if (this.widgetClosed) return;
	  
	  var wgs = webMercatorUtils.webMercatorToGeographic(e.mapPoint);
		
	  if (this.spinnerRun) return;

    this.apiKey.get("value").trim().length>0? this.userk=this.apiKey.get("value").trim():this.userk="";

    //AGO20181130 START
    /*
    if (this.isoValues.get("value")==iso4app.Distance.METERS_10000 || this.isoValues.get("value")=="9656m" ||
        this.isoValues.get("value")==iso4app.Time.SECONDS_600 ||
        this.userk.trim().length>0){
      this._createIsoline(wgs.y,wgs.x);
    } else {
      this._showRegistrationDialog();
	  }
	  */
    this._reEngine();//se cambio chiave necessario ricaricare engine
    if (this._checkUserK()) {
      setTimeout(function(){
        that.spinnerRun=true;
        that.spinner.show();
      },10);

      setTimeout(function(){
        that._doIsoline(wgs.y,wgs.x,false)
        that.spinner.hide();
        that.spinnerRun=false;
      },100);
    }
    //AGO20181130 END
	},
	
	_setRegistrationKey: function (key) {
	  this.userk=key;
	  this.apiKey.set("value",key);
    },
	
	_setFormRegistrationKey: function () {
	  this._setRegistrationKey(this.formApiKey.get("value"));
    },

	_populateMenu: function (distanceValue, timeValue, approxValue, mobilityValue, speedTypeValue, fillSpeedLimit) {
		var distanceDefaultValue = "10000m";
		var timeDefaultValue = "600s";
		var approxDefaultValue = "100";
		var mobilityDefaultValue = "m";
		var speedTypeDefaultValue = "30";
    //20180717 PATCH START
    var distanceInMilesDefaultIdx = "9656m";
    var approxInMilesDefaultIdx = "122";
    //20180717 PATCH END
		
		var isoType = this.isoType.get("value")
		var isoCategoryValue = this.category.get("value")
		var miles = this.miles.get("value");

    //20180717 PATCH START
    // Non vi è più corrispondenza tra miglia e metri, dunque si riapplicano sempre i default
    //OLD-> if (distanceValue==null) distanceValue = distanceDefaultValue;
    distanceValue = (miles)?distanceInMilesDefaultIdx:distanceDefaultValue;
    //20180717 PATCH END

		if (timeValue==null) timeValue = timeDefaultValue;

    //20180717 PATCH START
    // Non vi è più corrispondenza tra miglia e metri, dunque si riapplicano sempre i default
    //OLD-> if (approxValue==null) approxValue = approxDefaultValue;
    approxValue = (miles)?approxInMilesDefaultIdx:approxDefaultValue;
    //20180717 PATCH END

    if (mobilityValue==null) mobilityValue = mobilityDefaultValue;
		if (speedTypeValue==null) speedTypeValue = speedTypeDefaultValue;
		
		if (isoCategoryValue=="") this._populateCategory();
		
		if (isoType=="0"){
			this._populateDistances(miles,distanceValue);
			this.isoSpeedType.set('disabled', true);
			this.speedLimit.set('disabled', true);
			this.reduceQueueTime.set('disabled', true);
      this._populateApprox(miles,approxValue);
			this._populateMobility(mobilityValue);
			this._populateSpeedType(speedTypeValue);
			this._suggestSpeedLimit(false);
		} else {
			this._populateIntervals(timeValue);
			this.isoSpeedType.set('disabled', false);
			this.speedLimit.set('disabled', false);
			this.reduceQueueTime.set('disabled', false);
      this._populateApprox(miles,approxValue);
			this._populateMobility(mobilityValue);
			this._populateSpeedType(speedTypeValue);
			this._suggestSpeedLimit(fillSpeedLimit);
		}

    this.fastestRouting.set('disabled', !(isoType=="0" && mobilityValue=="m"));//20180703
    this.allowPedestrianBikeOnTrunk.set('disabled', mobilityValue=="m");//20180703
    if (mobilityValue=="m") this.allowPedestrianBikeOnTrunk.set('value', false);//20180703
		this.allowicyclesOnPedestrian.set('disabled', !(mobilityValue=="b"));

	 },
	 
	_populateDistances: function (milesChecked,selectedValue) {
		var optionText, optionValue;
		var meters, kilometers, miles, foot;
		var metersTxt, kilometersTxt, milesTxt, footTxt;
		
		//label
		this.isoDistanceLbl.innerHTML="Distance";

		// clear
		this.isoValues.removeOption(this.isoValues.getOptions());
		
		for (var prop in iso4app.Distance) {
			meters = iso4app.Distance[prop].substr(0,iso4app.Distance[prop].length-1);
			metersTxt = meters+" m"
			kilometers = parseInt(iso4app.Distance[prop])/1000;
			kilometersTxt = kilometers+" km";
			//20180717 PATCH START
      //OLD-> miles = this._meters2miles(parseInt(iso4app.Distance[prop]));
      miles = meters;
      //OLD-> milesTxt = miles+" mi";
      milesTxt = kilometers+" mi";
      //OLD-> foot = this._meters2foot(parseInt(iso4app.Distance[prop]));
      foot = meters;
			//20180717 PATCH END
      footTxt = foot+" ft";

      //20180717 PATCH START
      //OLD-> optionValue=iso4app.Distance[prop];
      //20180717 PATCH END

			//testo in base a presenza di miglia
			if (!milesChecked) {
        //20180717 PATCH START
        optionValue=iso4app.Distance[prop];
        //20180717 PATCH END
				optionText=(meters>=1000)?kilometersTxt:metersTxt;
			} else {
				//20180717 PATCH START
        //OLD-> optionText=(meters>=160)?milesTxt:footTxt;
        if (meters>=1000) {
          optionValue=this._miles2meters(parseFloat(kilometers))+"m";
          optionText=milesTxt;
        } else {
          optionValue=this._feet2meters(parseFloat(meters))+"m";
          optionText=footTxt;
        }
        //20180717 PATCH END
			}

      //20180717 PATCH START
      if (!milesChecked || (milesChecked && meters<=300000 && meters>=400)) {
        //20180717 PATCH END
        this.isoValues.addOption({label: optionText,value: optionValue});
      }
		}
		this.isoValues.set("value",selectedValue);

	 },
	
	_populateIntervals: function (selectedValue) {
		var optionText, optionValue, time, txt;
		var hours, minutes;
		var hoursTxt, minutesTxt;
		
		//label
		this.isoDistanceLbl.innerHTML="Time";

		// clear
		this.isoValues.removeOption(this.isoValues.getOptions());

		for (var prop in iso4app.Time) {
			optionValue=iso4app.Time[prop];

			time = parseInt(iso4app.Time[prop].substr(0,iso4app.Time[prop].length-1));

			if (time<3600) {
			  txt = time/60+" min";
			} else if (time>=3600) {
			  hours = parseInt(time/3600);
			  minutes = parseInt((time-hours*3600)/60);
			  txt = (minutes==0)?hours+" h":hours+ " h and "+minutes+" min";
			}
			optionText=txt;
			
			this.isoValues.addOption({label: optionText,value: optionValue});
		}
		
		this.isoValues.set("value",selectedValue);
	 },
	
	_populateApprox: function (milesChecked,selectedValue) {
		  var optionText, optionValue;
		  var meters, kilometers, miles, foot;
		  var metersTxt, kilometersTxt, milesTxt, footTxt;
		  var approxv = [50,100,200,300,400,500,600,700,800,900,1000,1500,2000,2500,3000,4000,5000];
		  var isoApprox = document.getElementById("isoApprox");

		  // clear
		  this.isoApprox.removeOption(this.isoApprox.getOptions());

		  //populate
		  for (var i=0; i<approxv.length; i++){
        meters = approxv[i];
        metersTxt = meters+" m"
        kilometers = approxv[i]/1000;
        kilometersTxt = kilometers+" km";
        //20180717 PATCH START
        //OLD-> miles = this._meters2miles(parseInt(approxv[i]));
        miles = kilometers;
        //20180717 PATCH END
        milesTxt = miles+" mi";
        //20180717 PATCH START
        //OLD-> foot = this._meters2foot(parseInt(approxv[i]));
        foot = meters;
        //20180717 PATCH END
        footTxt = foot+" ft";

        //20180717 PATCH START
        //OLD-> optionValue=approxv[i];
        //20180717 PATCH END

        //testo in base a presenza di miglia
        if (!milesChecked) {
          //20180717 PATCH START
          optionValue=approxv[i];
          //20180717 PATCH END
          optionText=(meters>=1000)?kilometersTxt:metersTxt;
        } else {
          //20180717 PATCH START
          //OLD-> optionText=(meters>=160)?milesTxt:footTxt;
          if (meters>=1000) {
            optionValue=this._miles2meters(parseFloat(kilometers))+"m";
            optionText=milesTxt;
          } else {
            optionValue=this._feet2meters(parseFloat(meters))+"m";
            optionText=footTxt;
          }
          //20180717 PATCH END
        }

        //20180717 PATCH START
        if (!milesChecked || (milesChecked && meters<=3000 && meters>=400)) {
          //20180717 PATCH END
          this.isoApprox.addOption({label: optionText,value: optionValue});
        }
		  }
		  
		  this.isoApprox.set("value",selectedValue);
	},
	
	_populateMobility: function (selectedValue) {
		  var optionValue, optionText;
		  
		  if (!(this.isoMobility.getOptions()!=null && this.isoMobility.getOptions().length>0)){
			  
			  // clear
			  this.isoMobility.removeOption(this.isoMobility.getOptions());

			  optionValue="m";
			  optionText="Motor vehicle";
			  this.isoMobility.addOption({label: optionText,value: optionValue});
			  
			  optionValue="b";
			  optionText="Bicycle";
			  this.isoMobility.addOption({label: optionText,value: optionValue});
			  
			  optionValue="p";
			  optionText="Pedestrian";
			  this.isoMobility.addOption({label: optionText,value: optionValue});
		  }
		  
		  this.isoMobility.set("value",selectedValue);
	},
	
	_populateSpeedType: function (selectedValue) {
		  var optionValue, optionText;
		  var isoType = this.isoType.get("value");
		  var isoMobility = this.isoMobility.get("value");
		  var miles = this.miles.get("value");

		  this.speedLimitInfoLbl.innerHTML="";
		  
		  if (!(this.isoSpeedType.getOptions()!=null && this.isoSpeedType.getOptions().length>0)){
			  // clear
			  this.isoSpeedType.removeOption(this.isoSpeedType.getOptions());
			  
			  optionValue="10";
			  optionText="Very low";
			  this.isoSpeedType.addOption({label: optionText,value: optionValue});

			  optionValue="20";
			  optionText="Low";
			  this.isoSpeedType.addOption({label: optionText,value: optionValue});

			  optionValue="30";
			  optionText="Normal";
			  this.isoSpeedType.addOption({label: optionText,value: optionValue});

			  optionValue="40";
			  optionText="Fast";
			  this.isoSpeedType.addOption({label: optionText,value: optionValue});
		  }		  
		  this.isoSpeedType.set("value",selectedValue);
	},
	
	_suggestSpeedLimit: function (fillSpeedLimit){
		var isoSpeedTypeValue = this.isoSpeedType.get("value");
		var isoType = this.isoType.get("value");
		var isoMobility = this.isoMobility.get("value");
		var miles = this.miles.get("value");
		
		this.speedLimitInfoLbl.innerHTML="";
		
		if (isoSpeedTypeValue=="10" && fillSpeedLimit){ 
		  if (isoType=="1") {
			  if (isoMobility=="b") this.speedLimit.set("value",miles?"4.97":"8");
			  if (isoMobility=="p") this.speedLimit.set("value",miles?"1.86":"3");
		  } else {
			  this.speedLimit.set("value","");
		  }
		}
		
		if (isoSpeedTypeValue=="20" &&  fillSpeedLimit){ 
		  if (isoType=="1") {
			  if (isoMobility=="b") this.speedLimit.set("value",miles?"7.46":"12");
			  if (isoMobility=="p") this.speedLimit.set("value",miles?"2,73":"4.4");
		  } else {
			  this.speedLimit.set("value","");
		  }
		}
		
		if (isoSpeedTypeValue=="30" && fillSpeedLimit){ 
		  if (isoType=="1") {
			  if (isoMobility=="b") this.speedLimit.set("value",miles?"9.94":"16");
			  if (isoMobility=="p") this.speedLimit.set("value",miles?"3.36":"5.4");
		  } else {
			  this.speedLimit.set("value","");
		  }
		}

		if (isoSpeedTypeValue=="40"){
			if (fillSpeedLimit){
				if (isoType=="1") {
					  if (isoMobility=="b") {
						  this.speedLimit.set("value",miles?"24.85":"40");
						  this.speedLimitInfoLbl.innerHTML="High default speed value! You can reduce as you wish."
						}
					  if (isoMobility=="p") {
						  this.speedLimit.set("value",miles?"12.42":"20");
						  this.speedLimitInfoLbl.innerHTML="High default speed value! You can reduce as you wish."
						}
				  } else {
					  this.speedLimit.set("value","");
				  }
			} else {
				if (isoType=="1") {
					  if (isoMobility=="b") {
						  this.speedLimitInfoLbl.innerHTML="High default speed value! You can reduce as you wish."
						}
					  if (isoMobility=="p") {
						  this.speedLimitInfoLbl.innerHTML="High default speed value! You can reduce as you wish."
						}
				  }	
			}
		}
		
	},
	
	_populateCategory: function () {
	  // clear
	  this.category.removeOption(this.category.getOptions());

      this.category.addOption({label: "None",value: "0"});
	  //this.category.addOption({label: "Your data here? Plase contact us!",value: "0"});
	  this.category.addOption({label: "Accomodation",value: "1"});
	  this.category.addOption({label: "Amenity",value: "8"});
	  this.category.addOption({label: "Education",value: "19"});
	  this.category.addOption({label: "Food",value: "23"});
	  this.category.addOption({label: "Health",value: "30"});
	  this.category.addOption({label: "Bank/Exchange",value: "46"});
	  this.category.addOption({label: "Shop",value: "73"});
	  this.category.addOption({label: "Sport",value: "110"});
	  this.category.addOption({label: "Tourism",value: "137"});
	  this.category.addOption({label: "Transport",value: "159"});
	  this.category.addOption({label: "Italian population",value: "1000"});
      this.category.addOption({label: "England and Wales population",value: "2000"});
      this.category.addOption({label: "Switzerland population",value: "2600"});
      this.category.addOption({label: "France population",value: "2500"});
      this.category.addOption({label: "Germany population",value: "2800"});
      this.category.addOption({label: "South Africa",value: "2700"});
	  
	  this.category.set("value","0");
	},
	
	_getIsoTypes: function () {
		//Isolines Types
		var isoTypeOptions = [];
		isoTypeOptions.push({label: "Isodistance",value: "0"});
		isoTypeOptions.push({label: "Isochrone",value: "1"});
		
		return isoTypeOptions;
		
	},

	_getIsoConcavities: function () {
		//polygon concavities
		var isoConcavities = [];
		isoConcavities.push({label: "0 (convex)",value: "0",selected: false});
		isoConcavities.push({label: "1",value: "1",selected: false});
		isoConcavities.push({label: "2",value: "2",selected: false});
		isoConcavities.push({label: "3",value: "3",selected: false});
		isoConcavities.push({label: "4",value: "4",selected: false});
		isoConcavities.push({label: "5",value: "5",selected: true});
		isoConcavities.push({label: "6",value: "6",selected: false});
		isoConcavities.push({label: "7",value: "7",selected: false});
		isoConcavities.push({label: "8",value: "8",selected: false});
		
		return isoConcavities;
	},

	_getIsoBuffering: function () {
		//polygon buffering
		var isoBuffering = [];
		isoBuffering.push({label: "0 (no buffering)",value: "0",selected: true});
		isoBuffering.push({label: "1",value: "1",selected: false});
		isoBuffering.push({label: "2",value: "2",selected: false});
		isoBuffering.push({label: "3",value: "3",selected: false});
		isoBuffering.push({label: "4",value: "4",selected: false});
		isoBuffering.push({label: "5",value: "5",selected: false});
		isoBuffering.push({label: "6",value: "6",selected: false});
		isoBuffering.push({label: "7",value: "7",selected: false});
		isoBuffering.push({label: "8",value: "8",selected: false});
		
		return isoBuffering;
	},

	_showMsg: function (msg) {
		this.msgLbl.innerHTML=msg;
		this.myMsgDialog.show();
	},
	
	_reEngine: function () {
      var haveToReEngine = false;
	  var newK;
      if (this.userk.trim().length>0){
        if (this.lastk.trim()!=this.userk.trim()){
		  cookie("iso4app.key", this.userk.trim(), { expires: 30 });//si aggiorna il cookie
          newK = this.userk.trim();
          this.lastk = this.userk.trim();
          haveToReEngine = true;
        }
      } else {
		cookie("iso4app.key", "", { expires: -1 });//si rimuove il cookie
        if (this.lastk.trim()!=this.k.trim()){
          newK = this.k.trim();
          this.lastk = this.k.trim();
          haveToReEngine = true;
        }
      }
      if (haveToReEngine) this.iso.reKey(newK);
    },

	_showRegistrationDialog: function (){
    this.myFormDialog.show();
    },
    //AGO20181130 START
    _showBatchDialog: function (){

      PanelManager.getInstance().closePanel("_6_panel");

      this.myBatchDialog.show();
      domStyle.set(registry.byId("formBatchStopBtn").domNode, 'display', 'none');//nasconde bottone STOP
      domStyle.set(registry.byId("formBatchCopyBtn").domNode, 'display', 'none');//nasconde bottone COPY
      domUtils.hide(document.getElementById("batchIsRunning"));

      //pulizia tabella log
      var batchResultsTableTBody = document.getElementById("batchResultsTableTBody");
      batchResultsTableTBody.innerHTML ='';

      //aggiornamento totali elab
      this.batchResultsNumbers.innerHTML="";

      this.formBatchCoordinates.set("placeholder","latitude1 longitude1; latitude2 longitude2; latitude3 longitude3");
      this.formBatchCoordinates.set("rows",4);
      this.formBatchCoordinates.set("value","");

    },
    //AGO20181130 END

    //AGO20190107 START
    //OLD-> _addIndicator: function(indicator, colorGrid2d){
    _addIndicator: function(indicator, isolineId, colorGrid2d){
    //AGO20190107 END
      var polygons = [], coords, value, poly;
      var polyCoords;
		  var isoCategoryValue = this.category.get("value");
      var textCategory = this.category.get("displayedValue");

      var indicatorColorLevels = this._calculateNaturalBreaks(indicator, 5);
        
        if (null != indicator.polylines){
          for(var i = 0; i < indicator.polylines.length; i++){
            coords = indicator.polylines[i].coords.split(",");
            value = parseFloat(indicator.polylines[i].value)
            polyCoords = Array();
            var north = null, east = null;
            for(j = 0; j < coords.length; j++){
              coord = (coords[j]+"").trim().split(" ");
              polyCoords[j] = [parseFloat(coord[1]),parseFloat(coord[0])];

              //si calcola il punto più a nord est
              if (north==null || north<=parseFloat(coord[0])){
                north = parseFloat(coord[0]);
                if (east==null || east<parseFloat(coord[1])){
                  east = parseFloat(coord[1]);
                }
              }
            }
			var title = "Indicator summary";
			var tooltip = "Category:"+textCategory+
						"<br>Elements:"+value;
			
			var color =this._getEqIntervalsColor(value, colorGrid2d, indicatorColorLevels);
			var poly = new esri.geometry.Polygon(new esri.SpatialReference({wkid:4326}));  
			poly.addRing(polyCoords);  
		    // map is in web mercator so transform the geometry  
			var poly_wm = esri.geometry.geographicToWebMercator(poly);  
			var symbol = new SimpleFillSymbol(SimpleFillSymbol.STYLE_SOLID,
				new SimpleLineSymbol(SimpleLineSymbol.STYLE_SOLID,new Color([0,0,0,1]), 1),
				new Color([parseInt(color[0]),parseInt(color[1]),parseInt(color[2]),0.6])
			);
			polygons[i] = new esri.Graphic(
				poly_wm, 
				symbol,
				{ 'title': title, 'content': tooltip }, // attributes  
				new esri.InfoTemplate('${title}', '${content}')  
				);
            polygons[i].value = value;
            polygons[i].id = i;
            polygons[i].n = north;
            polygons[i].e = east;
            //AGO20190107 START
            polygons[i].isolineId = isolineId;
            polygons[i].textCategory = textCategory;
            polygons[i].colorIdx = this._getEqIntervalsColorIndex(value, colorGrid2d, indicatorColorLevels);
            polygons[i].wgscoords = polyCoords;
            //AGO20190107 END
			
			this.map.graphics.add(polygons[i]); 
          }
        }
        return polygons;
	},
	
	_removePreviousLayers: function(){
		//this.map.graphics.clear();
		if (this.startPoints.length>0){
			for (var i=this.startPoints.length-1; i>=0; i--) this.map.graphics.remove(this.startPoints[i]);
			this.startPoints = [];
		}
		if (this.polygons.length>0){
        for (var i=this.polygons.length-1; i>=0; i--) this.map.graphics.remove(this.polygons[i]);
        this.polygons = [];
		}

    /* AGO20190107 START
    if (null != this.startPoint) {
      this.map.graphics.remove(this.startPoint);
      this.startPoint = null;
    }
    if (null != this.polygon) {
      this.map.graphics.remove(this.polygon)
      this.polygon=null;
    }
     AGO20190107 END */
	},
	
	_removeIndicatorGrid: function(){
	   if (this.indicatorPolygons.length>0){
		for (var i=this.indicatorPolygons.length-1; i>=0; i--) {
			//indicatorPolygons[i].off('click');
			//indicatorPolygons[i].off('mouseover');
			//indicatorPolygons[i].off('mouseout');
			//indicatorPolygons[i].unbindPopup();
			this.map.graphics.remove(this.indicatorPolygons[i]);
		}
		indicatorPolygons= [];
	  }
	},
	
	_removePreviousChanged: function(){
		this.removePrevious=this.delPrevious.get("value");
		if (this.removePrevious) this._removePreviousLayers();
	},
	
	_removeAll: function(){
		this.map.graphics.clear();
		this.startPoints = [];
		this.polygons = [];
    this.indicatorPolygons= [];//20180703
	},
	
	_markersToFront: function(){},
	
	_int2rgb: function(i){
		var red = i>>16;
        var grnBlu = i-(red<<16);
        var grn = grnBlu>>8;
        var blu = grnBlu-(grn<<8);
        return({r:red, g:grn, b:blu});
	},
	
	_rgb2hex: function(r, g, b){
		var extVal = "00"+(r << 16 | g << 8 | b).toString(16);
        return "#"+extVal.substr(extVal.length - 6);
	},
	
	_getEqIntervalsColor: function(value, intcolor, colorLevels){
		var color = [255,255,255];
        if (value>0) {
            var rgb = this._int2rgb(intcolor);
            for (i=0; i<colorLevels; i++){
              if (value<=indicatorRange[i]) {
				color = [parseInt(rgb.r)+((255-parseInt(rgb.r))/colorLevels)*(colorLevels-i-1), rgb.g+((255-parseInt(rgb.g))/colorLevels)*(colorLevels-i-1), rgb.b+((255-parseInt(rgb.b))/colorLevels)*(colorLevels-i-1)];
                break;
              }
            }
        }
        return color;
	},

    //AGO20190107 NEW
    _getEqIntervalsColorIndex: function(value, intcolor, colorLevels){
      var colorIdx = 0;
      if (value>0) {
        for (i=0; i<colorLevels; i++){
          if (value<=indicatorRange[i]) {
            colorIdx = i;
            break;
          }
        }
      }
      return colorIdx;
    },

	_calculateNaturalBreaks: function(indicator, levels){
	  var minVal=9999999999, maxVal= 0, value, observations=[], nb=[];

	  indicatorRange = [];

	  if (null != indicator.polylines){
		for(i = 0; i < indicator.polylines.length; i++){
		  value =  parseFloat(indicator.polylines[i].value);
		  if (value < minVal) minVal = value;
		  if (value > maxVal) maxVal = value;
		  observations[observations.length]=value;
		}
	  }

	  // sort delle osservazioni (IMP)
	  observations.sort(function(a,b) { return parseFloat(a) - parseFloat(b) } );

	  // si calcolano i natural breaks
	  if (observations.length>0){
		nb = this._getNB(observations, levels);
		// IMPORTANTE: il calcolo dei natural breaks può RIDURRE il numero di colorLevels -> si ri-assegna colorLevels
		levels=nb.length;

		//si travasa il risultato sulla indicatorRange
		for (var i=0; i<nb.length; i++){
		  indicatorRange[i] = observations[nb[i]];
		}
	  }

	  return levels;
	},
	
	_getNB: function(obs, num){
		   //numerosità dati
          var numData = obs.length;
          var numClass = parseInt(num);

          var mat1 = this._getMultiDimArray(numData+1,numClass+1);
          var mat2 = this._getMultiDimArray(numData+1,numClass+1);
		  
          for (var i=1; i<= numClass; i++) {
			this._setMultiDimArrayCell(mat1,1,i,1);
			this._setMultiDimArrayCell(mat2,1,i,0);
            for (var j=2; j<=numData; j++) this._setMultiDimArrayCell(mat2,j,i,Number.MAX_VALUE); 
          }

          var v=0;
          var s1;
          var s2;
          var w;
          var i3;
          var i4;
          var val;

          for (var l=2; l<=numData; l++) {

            s1 = 0;
            s2 = 0;
            w = 0;

            for (var m=1; m<=l; m++) {
              i3 = l - m + 1;
              val = Number(obs[i3-1]);

              s2 += val * val;
              s1 += val;

              w++;
              v = s2 - (s1 * s1) / w;
              i4 = i3 - 1;
              if (i4 != 0) {
                for (var j=2; j<=numClass; j++) {
                  if ((this._getMultiDimArrayCell(mat2,l,j)) >= (v + (this._getMultiDimArrayCell(mat2,i4,j-1)))) {
                    this._setMultiDimArrayCell(mat1,l,j,i3);
                    this._setMultiDimArrayCell(mat2,l,j,v + (this._getMultiDimArrayCell(mat2,i4,j-1)));
                  }
                }
              }
            }
            this._setMultiDimArrayCell(mat1,l,1,1);
            this._setMultiDimArrayCell(mat2,l,1,v);
          }

          var k = numData;
          var kclass = new Array(numClass);
          var id;

          kclass[numClass-1] = parseInt(obs.length-1);

          for (var j=numClass; j>=2; j--) {
            id = parseInt(this._getMultiDimArrayCell(mat1,k,j))-2;
			kclass[j - 2] = id;
            k = parseInt(this._getMultiDimArrayCell(mat1,k,j))-1;
            // AGO Patch -> può capitare che k diventi negativo -> lo si riporta a 0
            if (k<0) k=0;
          };

          var definitiveKClass = new Array();
          for (var t=0; t<kclass.length; t++) {
            if (kclass[t]>=0) {
              if (definitiveKClass.length>0){
                if (definitiveKClass[definitiveKClass.length-1]!=kclass[t]&&obs[definitiveKClass[definitiveKClass.length-1]]!=obs[kclass[t]]) definitiveKClass[definitiveKClass.length]=kclass[t];
              } else {
                definitiveKClass[0]=kclass[t];
              }
            }
          }

          return definitiveKClass;
	},
	
	_addMarker: function (startPoint,polygon,color,title,tooltip,iconScale) {
		var coord = startPoint.split(" ");
		var pt = new esri.geometry.Point(parseFloat(coord[1]), parseFloat(coord[0]), new esri.SpatialReference({ 'wkid': 4326 }));  
		var symbol = new SimpleMarkerSymbol(SimpleMarkerSymbol.STYLE_CIRCLE, iconScale,
			new SimpleLineSymbol(SimpleLineSymbol.STYLE_SOLID,new Color([color[0],color[1],color[2]]), iconScale-2),
			new Color([color[0],color[1],color[2]]));
	
		var marker = new esri.Graphic(  
            esri.geometry.geographicToWebMercator(pt), // geometry  
            symbol, // symbol  
            { 'title': title, 'content': tooltip }, // attributes  
            new esri.InfoTemplate('${title}', '${content}')  
          );
		
		this.map.graphics.add(marker);  
		
		return marker;
	},
	
	_addPolygon: function (wgscoords,color,indicator) {
		var poly = new esri.geometry.Polygon(new esri.SpatialReference({wkid:4326}));  
		poly.addRing(wgscoords);  
		  
        // map is in web mercator so transform the geometry  
        var poly_wm = esri.geometry.geographicToWebMercator(poly);

		var symbol = new SimpleFillSymbol(SimpleFillSymbol.STYLE_SOLID,
			new SimpleLineSymbol(SimpleLineSymbol.STYLE_SOLID,new Color([color[0],color[1],color[2],1]), 2),
			new Color([color[0],color[1],color[2],indicator!=null?0:0.3])
		);
        var polygonGraphic = new esri.Graphic(poly_wm, symbol);
        polygonGraphic.wgscoords = wgscoords;//20180703
        this.map.graphics.add(polygonGraphic); 

		return polygonGraphic;
	},

  //20180703
  //AGO20181130 START
    /*
  _showBlob: function(stream, mimeType){
    var blob = new Blob([stream], {type: mimeType});
    var that = this;
    if (navigator.msSaveBlob) {
      console.log("-> 111");
      navigator.msSaveBlob(blob, "iso4app.geojson");
    } else {
      //si alza lo spinner
      this.spinnerRun=true;
      this.spinner.show();

      var link = document.createElement('a');
      link.href = (window.URL || window.webkitURL).createObjectURL(blob);
      link.target = "_blank";
      document.body.appendChild(link);
      //sotto ESRI l'appendChild è lenta -> importante il timeout di 2 secondi che segue (1 secondo non basta)
      setTimeout(function(){
        //si abbassa lo spinner
        that.spinner.hide();
        that.spinnerRun=false;
        //click sul link
        link.click();
        document.body.removeChild(link);
      }, 2000);
    }
  },
  */
    _showBlob: function(docStream, mimeType, fileName, onlyDownload){
      var blob = new Blob([docStream], {type: mimeType});
      var that = this;
      if (navigator.msSaveBlob) {
        navigator.msSaveBlob(blob, fileName);
      } else {
        //si alza lo spinner
        this.spinnerRun=true;
        this.spinner.show();

        var link = document.createElement('a');
        link.href = (window.URL || window.webkitURL).createObjectURL(blob);
        link.target = "_blank";
        if (onlyDownload) link.download = fileName;
        document.body.appendChild(link);
        //sotto ESRI l'appendChild è lenta -> importante il timeout di 2 secondi che segue (1 secondo non basta)
        setTimeout(function(){
          //si abbassa lo spinner
          that.spinner.hide();
          that.spinnerRun=false;
          //click sul link
          link.click();
          document.body.removeChild(link);
        }, 2000);
      }
    },
  //AGO20181130 END
  //20180703
  _getScreenGeometries: function(){
    var ret = "", coords, polycoords;

    for (var i=0; i<this.map.graphics.graphics.length;i++){
      //AGO20190107 START
      //OLD-> if (this.map.graphics.graphics[i].geometry!=null && this.map.graphics.graphics[i].geometry.type!=null && this.map.graphics.graphics[i].geometry.type == "polygon"){
      if (this.map.graphics.graphics[i].geometry!=null && this.map.graphics.graphics[i].geometry.type!=null &&
        this.map.graphics.graphics[i].geometry.type == "polygon" &&
        this.map.graphics.graphics[i].i4a!=null){
      //si cicla sulle sole isolinee (i4a!=null)
      //AGO20190107 END
        if (ret.length>0) ret+="|";
        polycoords = "";
        for (var j=0; j<this.map.graphics.graphics[i].wgscoords.length; j++) {
          if (polycoords.length>0) polycoords+=",";
          polycoords+=this.map.graphics.graphics[i].wgscoords[j][1]+" "+this.map.graphics.graphics[i].wgscoords[j][0];
        }
        ret += "py"+ "§" + this.map.graphics.graphics[i].i4a.type.toLowerCase() + "§";
        ret += this.map.graphics.graphics[i].i4a.value + "§";
        ret += this.map.graphics.graphics[i].i4a.mobility + "§";//AGO20190621
        ret += this.map.graphics.graphics[i].i4a.start + "§";
        ret += this.map.graphics.graphics[i].i4a.way.trim() + "§";
        ret += this.map.graphics.graphics[i].i4a.oneway + "§";
        ret += this.map.graphics.graphics[i].i4a.tollway+ "§";
        ret += this.map.graphics.graphics[i].i4a.approx+ "§";
        ret += polycoords;

        //AGO20190107 START
        var indicatorinfo="", indicatorCategoryText="", indicatorpolycoords;
        for (var q=0; q<this.map.graphics.graphics.length; q++){
          if (this.map.graphics.graphics[q].geometry!=null &&
            this.map.graphics.graphics[q].geometry.type!=null &&
            this.map.graphics.graphics[q].geometry.type == "polygon" &&
            this.map.graphics.graphics[q].isolineId!=null &&
            this.map.graphics.graphics[q].isolineId==this.map.graphics.graphics[i].i4a.id){
            //si cicla sui soli poligoni indicatore
            indicatorCategoryText = this.map.graphics.graphics[q].textCategory;
            indicatorpolycoords = "";
            for (var j=0; j<this.map.graphics.graphics[q].wgscoords.length; j++) {
              if (indicatorpolycoords.length>0) indicatorpolycoords+=",";
              indicatorpolycoords+=this.map.graphics.graphics[q].wgscoords[j][1]+" "+this.map.graphics.graphics[q].wgscoords[j][0];
            }
            if (indicatorinfo.length>0) indicatorinfo+="$";
            indicatorinfo+=this.map.graphics.graphics[q].value+";"+this.map.graphics.graphics[q].colorIdx+";"+indicatorpolycoords;
          }
        }
        if (indicatorinfo.length>0) ret += "§" + indicatorCategoryText + "§" + indicatorinfo;
        //AGO20190107 END

      }
    }
    return ret;
  },
  //20180703
  _screenKml: function(){
    var geometries = this._getScreenGeometries();
    if (geometries.length==0) return;

    //se cambio chiave necessario ricaricare engine
    this.apiKey.get("value").trim().length>0? this.userk=this.apiKey.get("value").trim():this.userk="";
    this._reEngine();

    //si chiede il geojson
	  //AGO20200904 START
    //OLD-> var screenKml = this.iso.getScreenKml(geometries);
    var screenKml = this.iso.getScreenKml(geometries+"£");
      //AGO20200904 END

    if (screenKml.errcode=="0"){
      //AGO20181130 START
      //OLD showBlob(screenKml.xml,"application/xml");
      this._showBlob(screenKml.xml,"application/xml","isolines.kml",true);
      //AGO20181130 END
    } else {
      this._showMsg(screenKml.errcode+"<br/>"+screenKml.errmsg.replace(". ", '.<br/>'));
    }
  },
  //20180703
  _screenGeoJson: function(){
      var geometries = this._getScreenGeometries();
      if (geometries.length==0) return;

      //se cambio chiave necessario ricaricare engine
      this.apiKey.get("value").trim().length>0? this.userk=this.apiKey.get("value").trim():this.userk="";
      this._reEngine();

      //si chiede il geojson
      //AGO20200904 START
      //OLD-> var screenGeoJson = this.iso.getScreenGeoJson(geometries);
      var screenGeoJson = this.iso.getScreenGeoJson(geometries+"£");
      //AGO20200904 END

      if (screenGeoJson.errcode=="0"){
        //AGO20181130 START
        //OLD _showBlob(screenGeoJson.jsontext,"application/json");
        this._showBlob(screenGeoJson.jsontext,"application/json","isolines.json",true);
        //AGO20181130 END
      } else {
        this._showMsg(screenGeoJson.errcode+"<br/>"+screenGeoJson.errmsg.replace(". ", '.<br/>'));
      }
    },
  //AGO20181130 START
    _isoBatch: function() {
      //se cambio chiave necessario ricaricare engine
      this.apiKey.get("value").trim().length>0? this.userk=this.apiKey.get("value").trim():this.userk="";
      this._reEngine();

      if (!this.iso.isCo()){
        this._showMsg("This feature requires a commercial API-Key.");
        return;
      }
      if (this._checkUserK()) {
        this._showBatchDialog();
      }
  },
  //AGO20181130 END
    //20180703
  _isoUnion: function () {

    if (this.polygons.length==0) return;

    //se cambio chiave necessario ricaricare engine
    this.apiKey.get("value").trim().length>0? this.userk=this.apiKey.get("value").trim():this.userk="";
    this._reEngine();

    //si chiede l'unione
    var isoJoin = this.iso.joinIsolines(this._getPoly4Union());

    if (isoJoin.errcode=="0"){
      this._replaceWithUnionResult(isoJoin);
    } else {
      this._showMsg(isoJoin.errcode+"<br/>"+isoJoin.errmsg.replace(". ", '.<br/>'));
    }
  },
  //20180703
  _getPoly4Union: function () {
    var ret = "", coords, polycoords;

    for (var i=0; i<this.map.graphics.graphics.length;i++){
      if (this.map.graphics.graphics[i].geometry!=null && this.map.graphics.graphics[i].geometry.type!=null && this.map.graphics.graphics[i].geometry.type == "polygon"){
        if (ret.length>0) ret+="|";
        polycoords = "";
        for (var j=0; j<this.map.graphics.graphics[i].wgscoords.length; j++) {
          if (polycoords.length>0) polycoords+=",";
          polycoords+=this.map.graphics.graphics[i].wgscoords[j][0]+" "+this.map.graphics.graphics[i].wgscoords[j][1];
        }
        ret+=polycoords;
      }
    }
    return ret;
  },

  //AGO20181130 START
    _addBatchRow: function(coords,result,isError){
      var batchResultsTable = document.getElementById("batchResultsTable");
      var row = batchResultsTable.insertRow(0);
      var cell1 = row.insertCell(0);
      cell1.style.width="40%";
      cell1.style.fontSize="9px";
      var cell2 = row.insertCell(1);
      cell2.style.color=isError!=null&&isError?"red":"green";
      cell2.style.fontSize="9px";
      cell1.innerHTML = coords;
      cell2.innerHTML = result;

      isoBatchLog=coords+'\t'+result+"\n"+isoBatchLog;
      domStyle.set(registry.byId("formBatchCopyBtn").domNode, 'display', 'inline-block');//visualizza bottone COPY

      //aggiornamento totali elab
      this.batchResultsNumbers.innerHTML = 'Total:&nbsp;'+isoBatchTotal+
        '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Processed:&nbsp;'+isoBatchProcessed+
        '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Errors:&nbsp;'+isoBatchErrors
    },
    _createIsoline: function (batchMode,lat,lng,speedLimit){
      var that = this;
      var properties = {
        maxdist : "",
        mobility : "",
        speedtype : "",
        maxvehiclespeed : "",
        reducequeue : "",
        avoidtollways : "",
        ssl : "",
        concavity : "",
        category : "",
        bicycleonpedestrian: "",
        restrictedareas:""
      }

      // si invoca il servizio
      properties.maxdist = that.isoApprox.get("value");
      properties.mobility = that.isoMobility.get("value");
      properties.speedtype = that.isoSpeedType.get("value");
      properties.maxvehiclespeed = speedLimit;
      properties.reducequeue = that.reduceQueueTime.get("value")?"1":"0";
      properties.fastestrouting = that.fastestRouting.get("value")?"1":"0";//20180703
      properties.pedestrianandbikeontrunk = that.allowPedestrianBikeOnTrunk.get("value")?"1":"0";//20180703
      properties.restrictedareas = that.restrictedAccessArea.get("value")?"1":"0";
      properties.avoidtollways = that.avoidTolls.get("value")?"1":"0";
      properties.bicycleonpedestrian = that.allowicyclesOnPedestrian.get("value")?"1":"0";
      properties.ssl = null;
      properties.concavity = that.isoConcavity.get("value");
      properties.buffering = that.isoBuffering.get("value");
      properties.category = that.category.get("value");
      //20180719
      properties.caller = "esri";

      var isoline = that.iso.getIsoline(lat, lng, that.isoValues.get("value"), properties);

      if (batchMode)  isoBatchProcessed++;

      if (isoline.errcode=="0"){
        //cmq si riempiono i previous
        if (null != that.polygon) that.polygons[that.polygons.length] = that.polygon;
        if (null != that.startPoint) that.startPoints[that.startPoints.length] = that.startPoint;

        //in ogni caso rimuovo la grid
        that._removeIndicatorGrid();

        //se necessario si eliminano i previous
        if (that.removePrevious && !batchMode) {
          that._removePreviousLayers();
          that.colorsIdx = 0;
        } else {
          that.colorsIdx = (that.colorsIdx)%that.colors.length;
        }
        that.color = that.colors[that.colorsIdx];
        that.colorsIdx+=1;

        var isoProps = {
          type: that.isoType.get("value")=="0"?"Isodistance":"Isochrone",
          value: that.isoValues.textDirNode.innerText,
          approx: that.isoApprox.textDirNode.innerText,
          start: isoline.startpoint,
          way: isoline.way.replace(/\|/g, " ").replace(/\§/g, " "),
          oneway: isoline.oneway,
          tollway: isoline.tollway,
          id: new Date().getTime(),//AGO20190107
          mobility: that.isoMobility.value //AGO20190621
        }
        //20180717 GESTIONE MIGLIA value e approx usano il "text" e non più il "value" END

        // add polygon
        var coord, title, tooltip;
        var isocoords = isoline.isocoords.split(",");
        var wgscoords = [], coord;
        for (var i=0;i<isocoords.length;i++){
          coord = isocoords[i].split(" ");
          wgscoords[wgscoords.length] = [parseFloat(coord[1]),parseFloat(coord[0])];
        }
        that.polygon = that._addPolygon(wgscoords,that.color,isoline.indicator);

        if (batchMode){
            //aggiornamento del bbox dei poligoni richiesti in modalità batch
          if (isoBatchExtent!=null){
            if (isoBatchExtent.xmax < that.polygon._extent.xmax) isoBatchExtent.xmax = that.polygon._extent.xmax;
            if (isoBatchExtent.ymax < that.polygon._extent.ymax) isoBatchExtent.ymax = that.polygon._extent.ymax;
            if (isoBatchExtent.xmin > that.polygon._extent.xmin) isoBatchExtent.xmin = that.polygon._extent.xmin;
            if (isoBatchExtent.ymin > that.polygon._extent.ymin) isoBatchExtent.ymin = that.polygon._extent.ymin;
          } else {
            isoBatchExtent =that.polygon._extent;
          }
          //console.log("extent",isoBatchExtent);
        }

        that.polygon.i4a = {};//20180703
        Object.assign(that.polygon.i4a, isoProps);//20180703

        //add indicator
        if (isoline.indicator!=null){

          //AGO20190107 START
          //OLD-> that.indicatorPolygons = that._addIndicator(isoline.indicator, that.colorGrid2d);
          that.indicatorPolygons = that._addIndicator(isoline.indicator, isoProps.id, that.colorGrid2d);
          //AGO20190107 END
        }

        //add marker
        title = that.isoType.get("displayedValue")+" - "+that.isoValues.get("value");
        tooltip = "<u>Start point info</u>"+
          "<br>&nbsp;Coordinate:"+isoline.startpoint+
          "<br>&nbsp;Oneway:"+isoline.oneway+
          "<br>&nbsp;Toll:"+isoline.tollway;;
        if (isoline.way!='') tooltip=tooltip+"<br>&nbsp;Way:"+isoline.way;

        if (isoline.indicator!=null){
          var totIndicator=0;
          if (null != isoline.indicator.polylines) {
            for (var i = 0; i < isoline.indicator.polylines.length; i++) {
              totIndicator+=parseFloat(isoline.indicator.polylines[i].value)
            }
          }
          tooltip=tooltip+"<br>&nbsp;"+that.category.get("displayedValue")+":"+totIndicator;
        }

        that.startPoint = that._addMarker(isoline.startpoint,null,that.color,title,tooltip,7);

        if (batchMode) this._addBatchRow("latitude:"+lat+"    longitude:"+lng,'isoline OK', false);
      } else {
        if (batchMode){
          isoBatchErrors++;
          this._addBatchRow("latitude:"+lat+"    longitude:"+lng,'['+isoline.errcode+'] '+isoline.errmsg, true);
        } else {
          that._showMsg(isoline.errcode+"<br/>"+isoline.errmsg.replace(". ", '.<br/>'));
        }
      }
    },
    _doIsoline: function(lat, lng, batchMode){
      var done = true;

      if (this._checkSpeedLimit()){
        var isoSpeedLimitValue = this.speedLimit!=null?this.speedLimit.get("value"):"";
        var miles = this.miles.get("value");
        var speedLimit = 0;
        var that = this;

        if (isoSpeedLimitValue.length>0){
          isoSpeedLimitValue=isoSpeedLimitValue.replace(",",".");
        }
        //se lo speedLimit è settato e significativo -> lo si riporta a km se necessario
        if (!isNaN(isoSpeedLimitValue) && isoSpeedLimitValue.length>0){
          speedLimit = miles?that._miles2km(isoSpeedLimitValue):isoSpeedLimitValue;
        }
        this._createIsoline(batchMode, lat,lng, speedLimit);
      }
      return done;
    },
    _checkUserK: function (){
      if (this.isoValues.get("value")==iso4app.Distance.METERS_10000 || this.isoValues.get("value")=="9656m" ||
        this.isoValues.get("value")==iso4app.Time.SECONDS_600 ||
        this.userk.trim().length>0){
        return true;
      } else {
        this._showRegistrationDialog();
        return false;
      }
    },
    _checkSpeedLimit: function (){
      var isoSpeedLimitValue = this.speedLimit!=null?this.speedLimit.get("value"):"";
      var isoMobilityValue = this.isoMobility.get("value");
      var miles = this.miles.get("value");
      var speedLimit = 0;
      var that = this;

      if (isoSpeedLimitValue.length>0){
        isoSpeedLimitValue=isoSpeedLimitValue.replace(",",".");
      }

      // deve essere numerico
      if (isNaN(that.speedLimit.get("value")) && that.speedLimit.get("value").length>0){
        that._showMsg("Speed limit must be numeric");
        return false;
      }

      //se lo speedLimit è settato e significativo -> lo si riporta a km se necessario
      if (!isNaN(isoSpeedLimitValue) && isoSpeedLimitValue.length>0){
        speedLimit = miles?that._miles2km(isoSpeedLimitValue):isoSpeedLimitValue;
      }

      if ((isoMobilityValue=="B"||isoMobilityValue=="b") && speedLimit>40) {
        that._showMsg("For Bicycle the speed limit cannot be over 40 kmh or 24.85 Miles");
        return false;
      }

      if ((isoMobilityValue=="P"||isoMobilityValue=="p") && speedLimit>20) {
        that._showMsg("For Pedestrian the speed limit cannot be over 20 kmh or 12.43 Miles");
        return false;
      }

      return true;
    },
    _isoBatchTick: function() {
      var done, coord;
      var that=this;

      if (isoBatchCoordsIdx < isoBatchCoords.length && !this.spinnerRun){

        //se ultima coordinata si interrompe il timeout
        if (isoBatchCoordsIdx==isoBatchCoords.length-1) {
          this._stopIsolinesBatch();
        }

        coord = isoBatchCoords[isoBatchCoordsIdx].trim().split(" ");
        if (coord[0]!=null) coord[0]=coord[0].replace(",",".");
        if (coord[1]!=null) coord[1]=coord[1].replace(",",".");

        if (coord.length==2 &&
          coord[0].trim().length>0 && !isNaN(coord[0].trim()) &&
          coord[1].trim().length>0 && !isNaN(coord[1].trim()) ){

          this.map.centerAt(new Point(parseFloat(coord[1]), parseFloat(coord[0])));

          setTimeout(function(){
            that._doIsoline(wgs.y,wgs.x,false)
            that.spinner.hide();
            that.spinnerRun=false;
          },100);

          setTimeout(function(){
            that._doIsoline(parseFloat(coord[0]).toFixed(7),parseFloat(coord[1]).toFixed(7),true)

            that.spinner.hide();
            that.spinnerRun=false;

            if (isoBatchExtent!=null) that.map.setExtent(isoBatchExtent, true);

            isoBatchCoordsIdx++;
          },100);

        } else {
          isoBatchErrors++;
          this._addBatchRow(isoBatchCoords[isoBatchCoordsIdx],'wrong coordinates', true);
          isoBatchCoordsIdx++;
        }
      }
    },
    _batchResultsCopy: function() {
      if (!navigator.clipboard) {
        var textArea = document.getElementById("batchCoordinatesClip");
        textArea.value = window.isoBatchLog;
        textArea.focus();
        textArea.select();
        try {
          document.execCommand('copy');
        } catch (err) {
        }
        document.getElementById("batchCoordinates").focus();

      } else {
        navigator.clipboard.writeText(isoBatchLog);
      }
      return false;
    },
    _closeIsolinesBatch: function (){
      this.myBatchDialog.hide();
    },
    _startIsolinesBatch: function (){
      var coordinates = this.formBatchCoordinates.get("value");

      if (coordinates==null || coordinates.trim().length==0) return;

      // reset variabili legate a batchmode
      isoBatchCoords = coordinates.trim().split(";");
      isoBatchCoordsIdx = 0;
      isoBatchExtent = null;
      isoBatchTotal = isoBatchCoords.length;
      isoBatchProcessed = 0;
      isoBatchErrors = 0;
      isoBatchLog = "";

      //reset elementi di dialog
      domStyle.set(registry.byId("formBatchCopyBtn").domNode, 'display', 'none');//nasconde bottone COPY
      //pulizia tabella log
      var batchResultsTableTBody = document.getElementById("batchResultsTableTBody");
      batchResultsTableTBody.innerHTML ='';

      //aggiornamento totali elab
      this.batchResultsNumbers.innerHTML="";

      // sempre rimozione dei previous
      this._removePreviousLayers();
      this.colorsIdx = 0;

       // AGO20190107 START
       if (null != this.startPoint) {
       this.map.graphics.remove(this.startPoint);
       this.startPoint = null;
       }
       if (null != this.polygon) {
       this.map.graphics.remove(this.polygon)
       this.polygon=null;
       }
       // AGO20190107 END

      // in questa modalità non si può richiedere l'indicatore
      if (parseInt(this.category.get("value"))>0){
        this._showMsg("This mode does not allow the use of categories");
        return true;
      }

      this.apiKey.get("value").trim().length>0? this.userk=this.apiKey.get("value").trim():this.userk="";
      this._reEngine();

      if (this._checkUserK()) {
        // tasto STOP visibile e tasto START invisibile
        domStyle.set(registry.byId("formBatchStartBtn").domNode, 'display', 'none');//nasconde bottone START
        domStyle.set(registry.byId("formBatchCloseBtn").domNode, 'display', 'none');//nasconde bottone CLOSE
        domStyle.set(registry.byId("formBatchStopBtn").domNode, 'display', 'inline-block');//visualizza bottone STOP
        domUtils.show(document.getElementById("batchIsRunning"));

        this._isoBatchTick();
        isoBatchTimer = window.setInterval(this._isoBatchTick.bind(this), 2000);
        return false;//il false non chiude la dialog

      } else {
        return true;
      }

    },
    _stopIsolinesBatch: function(){
      // tasto STOP invisibile e tasto START visibile
      domStyle.set(registry.byId("formBatchStartBtn").domNode, 'display', 'inline-block');//visualizza bottone START
      domStyle.set(registry.byId("formBatchCloseBtn").domNode, 'display', 'inline-block');//visualizza bottone CLOSE
      domStyle.set(registry.byId("formBatchStopBtn").domNode, 'display', 'none');//nasconde bottone STOP
      domUtils.hide(document.getElementById("batchIsRunning"));

      //clear interval
      clearTimeout(isoBatchTimer);

      return false;
    },
  //AGO20181130 END

  //20180703
  _replaceWithUnionResult: function (unionPolys) {

    // rimozione totale
    this._removeAll();

    // si riparte con i colori
    this.colorsIdx = 0;
    this.color = this.colors[this.colorsIdx];
    this.colorsIdx+=1;

    // si aggiungono i poligoni esito della union
    var wgscoords;
    for (i = 0; i < unionPolys.length; i++) {
      wgscoords = [];
      for (j = 0; j < unionPolys[i]["exterior"].length; j++) {
        wgscoords.push([unionPolys[i]["exterior"][j][0],unionPolys[i]["exterior"][j][1]]);
      }
      //cmq si riempiono i previous
      if (null != this.polygon) this.polygons[this.polygons.length] = this.polygon;

      this.polygon = this._addPolygon(wgscoords,this.color);
      this.polygon.i4a = {
        type: "",
        value: "",
        approx: "",
        start: "",
        way: "",
        oneway: "",
        tollway: ""
      };
    }
  },

    _meters2miles: function (meters) {
		return parseFloat(parseFloat(meters) * 0.000621371).toFixed(2);
	},
	
	_meters2foot: function (meters) {
		return parseFloat(parseFloat(meters) * 3.28084).toFixed(0);
	},
	
	_miles2meters: function (miles) {
		return parseFloat(parseFloat(miles) * 1609.34).toFixed(0);
	},
  //20180717 PATCH START
  _feet2meters: function (feet) {
      return parseFloat(parseFloat(feet) * 0.3048).toFixed(0);
  },
  _miles2km: function (miles) {
		return parseFloat(parseFloat(miles) * 1.60934).toFixed(2);
	},
	
	_km2miles: function (km) {
		return parseFloat(parseFloat(km) * 0.621371).toFixed(2);
	},
		
	_getMultiDimArray: function (rows, cols) {
		var multi_ = [];
		for(var r=0; r<rows; r++){
			multi_[r] = [];
			for(var c=0; c<cols; c++) multi_[r][c] = 0;
		}
		return multi_;
	},
	_getMultiDimArrayCell: function (multi, i, j) {return multi[i][j] ; },
	_setMultiDimArrayCell: function (multi, i, j, value) {multi[i][j] = value;}
	
	
	
	
		
  });
});